from threading import *
import logging
import server_funcs
from Socket import *


def main():
    """
    Add documentation here
    """
    with Socket() as server_socket:
        server_socket.bind(('127.0.0.1', 6969))
        server_socket.listen(1)
        finished = False
        while not finished:
            client_socket, client_adress = server_socket.accept()
            Thread(target=handle_client, args=(client_socket,)).start()


def handle_client(soc: [socket.socket, Socket]):
    try:
        with to_Socket(soc) as client_socket:
            done = False
            while not done:
                data = to_str(client_socket.recv_sized()).split(' ')  # split data into command and parameters
                command = data[0].lower()
                parameters = data[1:]
                try:
                    func = getattr(server_funcs, command)
                    # if the function decides to disconnect from the client, it returns True. else nothing (None==false)
                    done = func(client_socket, *parameters)
                except AttributeError:
                    client_socket.send_sized(f'the command {command} does not exist')
                except TypeError:
                    client_socket.send_sized('wrong number of arguments')
                except Exception as e:
                    logging.error(e)
                    client_socket.send_sized(str(e))
                    raise e
    except ConnectionResetError:
        logging.error('client has exited unexpectedly')
                


if __name__ == '__main__':
    main()
